# TODOs

----------------------------------------------------------------------------------------------------------------------------------------------------------------

## Technical / Programming

-   try out PDF generation via [Typst](https://quarto.org/docs/output-formats/typst.html); once support for Quarto's article layout classes [is
    implemented](https://quarto.org/docs/output-formats/typst.html#known-limitations), Typst should hopefully prove way less frustating than LaTeX!

-   explain pre-assembly step (`rdb.report:preassemble()`) in the intro vignette

-   add some time-insensitive sentinel for plot generation and regenerate plots only if sentinel has changed

-   make all static versions of htmlwidgets (plotly charts etc.) link to interactive ones

-   add an [`inst/CITATION`](https://r-pkgs.org/misc.html#sec-misc-inst-citation) file to repo that defines how the report is to be cited; see
    [plotly's](https://github.com/plotly/plotly.R/blob/master/inst/CITATION) for an example

-   add fns to visualize moving averages; see the [slider](https://slider.r-lib.org/) package for data prep

-   experiment with *bump charts* to visualize rankings over time using pkg [ggbump](https://github.com/davidsjoberg/ggbump) and *sankey bump charts* to also
    visualize the underlying absolute values using pkg [ggsankey](https://github.com/davidsjoberg/ggsankey#geom_sankey_bump)

-   experiment with [interactive gt tables](https://gt.rstudio.com/reference/opt_interactive.html) in HTML output; would be great if we could create all tbls
    with gt and avoid having to create separate [DT](https://rstudio.github.io/DT/) tables for interactive output!

-   Visual polishing: Consider using

    -   [Bootstrap Icons](https://icons.getbootstrap.com/). There's a dedicated Quarto extension [available](https://github.com/shafayetShafee/bsicons). There's
        also an R package [bsicons](https://github.com/rstudio/bsicons) available.
    -   CSS animations based on [Animate.css](https://animate.style/). There's a dedicated Quarto extension
        [available](https://github.com/mcanouil/quarto-animate).

-   Further tweak [custom Pandoc LaTeX template](https://quarto.org/docs/journals/templates.html#template-partials)
    `input/report/assets/templates/template.latex`

    -   using `\usepackage{footnotebackref}` to add backlinks to footnote references (same as for the [Eisvogel Pandoc
        template](https://github.com/Wandmalfarbe/pandoc-latex-template#custom-template-variables) (`footnotes-disable-backlinks`)) has no effect -\> further
        investigate!

-   add [Pandoc Lua filter](https://quarto.org/docs/extensions/lua.html) that adds an [autogenerated `id`
    attribute](https://pandoc.org/MANUAL.html#extension-auto_identifiers) to `<dt>` elements inside definition lists (`<dl>` elements).

    proposed [upstream](https://github.com/quarto-dev/quarto-cli/issues/1697#issuecomment-1462441697)... let's wait for now.

-   implement pkgdown article ToC generation for headers \< h2, cf. <https://github.com/r-lib/pkgdown/issues/1357#issuecomment-2450526911>

### Bug reports / upstream issues

-   HTML figure output does not respect the `fig-column` chunk opt when `fig-subcap` is set, cf. <https://github.com/quarto-dev/quarto-cli/issues/8763>. Note
    that setting [`column`](https://quarto.org/docs/authoring/article-layout.html#code-cell-options) instead of (or in addition to) `fig-column` has a visual
    effect, but results in subpar layout. Possible workaround is [very clunky](https://github.com/quarto-dev/quarto-cli/issues/8763#issuecomment-1951461094), so
    we're just waiting for a proper upstream fix.

    Note that also setting `layout-ncol: 1` results in broken layout (makes fig left-aligned instead of centered in page) -\> submit separate bug report?

-   report Quarto bugs:

    -   Setting `fig-column` (in contrast to `column`) on htmlwidget output has no effect anymore since Quarto 1.5 (or already 1.4? it worked in 1.3.450!)

    -   submit bug report about not being able to use YAML expressions (`!expr 'ifelse(knitr::is_html_output(), "body", "page")'`) in chunk opts
        `tbl-column`/`fig-column`:

        ```         
        ERROR: Validation of YAML cell metadata failed.
        ERROR: Render failed due to invalid YAML.
        ```

        note that as a workaround, the option can be set on the upper chunk fence line via
        ```` ```{r, tbl-column` = ifelse(knitr::is_html_output(), "body", "page")} ````.

        fixing this would allow us to set the `tbl-column: !expr 'ifelse(knitr::is_html_output(), "body", "page")'` option YAML-based for chunk
        `tbl-n-bd-per-wave-top-ten` in `overall/trend-analyis.qmd`.

    -   when rendering profile `"html-minimal"`, the file `hypthesis.qmd` is wrongly left in the output dir (probably since we didn't include it in `chapters`
        or `appendices`) -\> create minimal reprex!

    -   layout bug in mobile view -\> hypothes.is toolbar overlaps search button!

    -   an e-mail address formatted as inline code ([`some@one.com`](mailto:some@one.com)) is rendered to `<code>some@one.com</code>`!

    -   feature request for new config opt `tbl-pos` similar to the existing `fig-pos`!

    -   [external links](https://quarto.org/docs/output-formats/html-basics.html#external-links):

        -   skip for
            -   `mailto:` links
            -   `file:` links (relevant when viweing rendered HTML files directly from disk in browser, i.e. not served by a local web server)
            -   `<a>` elements that only contain icons (`<i>`)
            -   links in the `page-footer`
        -   document supported regex syntax for `link-external-filter`. word boundaries (`\b`) used to work (in Quarto v1.2) but now don't (in v1.3).

    -   titles of figures which are not part of a [figure panel](https://quarto.org/docs/authoring/figures.html#figure-panels) are formatted differently in HTML
        output because their `<figcaption>` element is *below* the main `<figure>` element, while for panel figures, `<figcaption>` element is *besides* the
        `<figure>` element. -\> create reprex! related: <https://github.com/quarto-dev/quarto-cli/issues/1346>

    -   with [`fig-cap-location: top`](https://quarto.org/docs/authoring/figures.html#caption-locations) and 2-or-more column [figure
        panels](https://quarto.org/docs/authoring/figures.html#figure-panels) and *long* (i.e. multiline) figure subtitles, the alignment of the resulting
        subfigures is subpar. Setting `\floatsetup[figure]{style=Plaintop, ...}` has no effect on this (cf. chapter 3.1.1 Float Style in [floatrow
        documentation](http://mirrors.ctan.org/macros/latex/contrib/floatrow/floatrow.pdf)) -\> create minimal reprex and, if issue also occurs in vanilla
        Quarto layout without our floatrow setup, report it upstream!

-   test if RStudio's citation insertion feature properly respects CSL-JSON's `citation-key` field (should take precedence over `id`), and if not, create reprex
    and [open issue](https://github.com/rstudio/rstudio/issues); cf. <https://github.com/zotero/dataserver/issues/119>

-   Quarto [section cross-references](https://quarto.org/docs/authoring/cross-references.html#sections) to book *parts* don't seem to work (while referencing
    chapters works). Submit feature request with minimal reprex.

    Besides, section cross-references to book appendices don't respect the config option `crossref.appendix-title` and just print "Chapter $$A-Z$$". Submit
    separate bug report.

-   Once [quarto-dev/quarto-cli#3157](https://github.com/quarto-dev/quarto-cli/issues/3157) is fixed, set `engine: knitr` globally in `_quarto.yml`.

### Report

-   Add some "key indicators" using bslib's [value boxes](https://rstudio.github.io/bslib/articles/value-boxes.html#expandable-sparklines) (with expandable
    graphs)

    -   on report's landing page (overall indicators).
    -   per country; we could include various external info like scores on common [political
        indices](https://de.wikipedia.org/wiki/Kroatien#Politische_Indizes).

-   Include copyright and license info in all SVG plots and hide its container element via CSS, so when plots are downloaded, the info is visible.

-   experiment with [Quarto tabsets](https://quarto.org/docs/output-formats/html-basics.html#tabsets) and the [`grouped-tabsets`
    extension](https://github.com/quarto-ext/grouped-tabsets); we could e.g show a tab for

    -   analysis by referendum vs. ballot date
    -   each subregion in a specific region
    -   plot vs. table
    -   etc.

-   experiment with [knitr caching](https://quarto.org/docs/projects/code-execution.html#cache); the [`cache.extra` chunk
    opt](https://yihui.org/knitr/demo/cache/#even-more-stuff-for-cache) might allow enough finetuning

-   restore `plot_bar_rfrnds_per_period()`?

-   choose (and tweak) a different CSL file which is really optimized for Quarto's inline footnotes?

    make sure to rely on [CSL locale files](https://docs.citationstyles.org/en/stable/primer.html#locale-files)!

    -   [ISO 690](https://en.wikipedia.org/wiki/ISO_690)-based; though [this
        article](https://www.citavi.com/de/nuetzliche-irrtuemer/artikel/normgerecht-zitieren) states the standard has flaws;

        we'd base the CSL file on

        -   [`iso690-full-note-with-ibid-ro`](https://github.com/citation-style-language/styles/blob/v1.0.2/iso690-full-note-with-ibid-ro.csl) as base
        -   [`iso690-numeric-lt.csl`](https://github.com/citation-style-language/styles/blob/v1.0.2/iso690-numeric-lt.csl) for superscript refs
        -   [`iso690-numeric-cs.csl`](https://github.com/citation-style-language/styles/blob/v1.0.2/iso690-numeric-cs.csl) for properly indented bib?

-   As main font, consider [ET Book](https://edwardtufte.github.io/et-book/), i.a. used by [Tufte CSS](https://edwardtufte.github.io/tufte-css/). Note that
    [\@dpk is currently overhauling the font](https://github.com/edwardtufte/et-book/pull/25) in a [separate
    fork](https://github.com/edwardtufte/et-book/pull/25), might be better to first await some stable release from her.

    Since ET Book is not available on Google Fonts, we have to include it manually. We could generate the files using `sass::font_face()` in
    `report_update_fonts()`, something like:

    ``` r
    sass::font_face(family = "etbook",
                    src = "url(/assets/font/ETBook/etbookot-roman-webfont.woff2) format('woff2')",
                    style = "normal",
                    weight = "400",
                    display = "swap")
    ```

### Dashboard

-   create dashboard (skeleton) to be deployed to `dashboard.rdb.vote`

    technical:

    -   R package [**flexdashboard**](https://rmarkdown.rstudio.com/flexdashboard/) seems promising, see also chapter
        [Dashboards](https://bookdown.org/yihui/rmarkdown/dashboards.html#dashboards) in *R Markdown: The Definitive Guide*; the underlying Bootstrap theme can
        easily be customized via R package [fresh](https://dreamrs.github.io/fresh/)
    -   [Quarto dashboards](https://quarto.org/docs/dashboards/) seem to be quite mature, maybe the more future-proof choice?

    Fill dashboard with plots which summarize the most relevant info at a glance; maybe limit this to *overall* status-like info? or create two separate (or
    more) dashboards?

----------------------------------------------------------------------------------------------------------------------------------------------------------------

## Content

### Fundamentals

-   Grundsätzlich:

    -   Land-für-Land (vorerst nur auf nationaler Basis); siehe auch [*Referendums by country* on
        Wikipedia](https://en.wikipedia.org/wiki/Referendums_by_country)
    -   Aggregiert nach Weltregionen ("Weltbank-Regionen" o.ä.)
    -   Top-Ten (oder wieviel auch immer) je 5 Jahre, à la Heatmaps
    -   Appendix mit Vorlagen nach Land und einigen ausgewählten

-   Immer enthalten: Auflistung aller Abstimmungen pro Land im aktuellen Jahr mit vielen schönen Zusatzangaben aus den Datenbank-Variablen; Länder nach
    Kontinenten bzw. Weltregionen strukturieren

### Brainstorming

-   Anhang

    -   Changelog für den Report

### Inspirations

-   see Google Drive folder [`RDB/Annual Report/Inspirations/`](https://drive.google.com/drive/folders/1Z6IsBspB4LmHR-Q4TnzDaKONRymweOZo)

-   [participation](https://www.defacto.expert/2020/03/30/wahlteilnahme/)

----------------------------------------------------------------------------------------------------------------------------------------------------------------

## Outreach

-   [Jahrbuch für direkte Demokratie](https://ius.unibas.ch/de/personen/nadja-braun-binder/jahrbuch-fuer-direkte-demokratie/)

-   [V-Dem Democracy Index](https://en.wikipedia.org/wiki/V-Dem_Institute) (Altman stützt sich für einen Direkte-Demokratie-Unter-Index auf die RDB ohne die
    Quelle sauber zu zitieren...)
